c@a
c@versb
C-----------------------------------------------------------------------
C
CVERS                  Code_Saturne version 1.3
C                      ------------------------
C
C     This file is part of the Code_Saturne Kernel, element of the
C     Code_Saturne CFD tool.
C
C     Copyright (C) 1998-2007 EDF S.A., France
C
C     contact: saturne-support@edf.fr
C
C     The Code_Saturne Kernel is free software; you can redistribute it
C     and/or modify it under the terms of the GNU General Public License
C     as published by the Free Software Foundation; either version 2 of
C     the License, or (at your option) any later version.
C
C     The Code_Saturne Kernel is distributed in the hope that it will be
C     useful, but WITHOUT ANY WARRANTY; without even the implied warranty
C     of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C     GNU General Public License for more details.
C
C     You should have received a copy of the GNU General Public License
C     along with the Code_Saturne Kernel; if not, write to the
C     Free Software Foundation, Inc.,
C     51 Franklin St, Fifth Floor,
C     Boston, MA  02110-1301  USA
C
C-----------------------------------------------------------------------
c@verse
                        SUBROUTINE USPROJ
C                       *****************
C     -------------------------------------------------------------
     & ( IDBIA0 , IDBRA0 ,
     &   NDIM   , NCELET , NCEL   , NFAC   , NFABOR , NFML   , NPRFML ,
     &   NNOD   , LNDFAC , LNDFBR , NCELBR ,
     &   NVAR   , NSCAL  , NPHAS  ,
     &   NBPMAX , NVP    , NVEP   , NIVEP  , NTERSL , NVLSTA , NVISBR ,
     &   NIDEVE , NRDEVE , NITUSE , NRTUSE ,
     &   IFACEL , IFABOR , IFMFBR , IFMCEL , IPRFML , MAXELT , LSTELT ,
     &   IPNFAC , NODFAC , IPNFBR , NODFBR , ITEPA  ,
     &   IDEVEL , ITUSER , IA     ,
     &   XYZCEN , SURFAC , SURFBO , CDGFAC , CDGFBO , XYZNOD , VOLUME ,
     &   DT     , RTPA   , RTP    , PROPCE , PROPFA , PROPFB ,
     &   COEFA  , COEFB  ,
     &   ETTP   , ETTPA  , TEPA   , STATIS , STATIV , TSLAGR , PARBOR ,
     &   RDEVEL , RTUSER , RA     )
C     -------------------------------------------------------------
C***********************************************************************
C FONCTION :
C --------
c@foncb
CFONC
CFONC MODIFICATION UTILISATEUR EN FIN DE PAS DE TEMPS
CFONC    TOUT EST POSSIBLE,
CFONC
CFONC
CFONC ON DONNE ICI PLUSIEURS EXEMPLES :
CFONC
CFONC   - CALCUL DE BILAN THERMIQUE
CFONC     (au besoin, voir "ADAPTATION A UN SCALAIRE QUELCONQUE")
CFONC
CFONC   - MODIFICATION ARBITRAIRE D'UNE VARIABLE DE CALCUL
CFONC
CFONC   - EXTRACTION D'UN PROFIL 1D
CFONC
CFONC   - IMPRESSION D'UN MOMENT
CFONC
CFONC   - EXEMPLES D'UTILISATION DES ROUTINES DE PARALLELISME
CFONC
CFONC CES EXEMPLES SONT DONNES EN SUPPOSANT UN CAS AVEC PERIODICITE
CFONC   (IPERIO.GT.0) ET PARALLELISME (IRANGP.GE.0).
CFONC
CFONC
CFONC LE CALCUL DE BILAN THERMIQUE FOURNIT EN OUTRE UNE TRAME POUR
CFONC   PLUSIEURS CHOSES
CFONC   - CALCUL DE GRADIENT (AVEC LES PRECAUTIONS UTILES EN PARALLELE ET
CFONC     PERIODIQUE)
CFONC   - CALCUL DE GRANDEUR DEPENDANT DES VALEURS AUX CELLULES VOISINES
CFONC     D'UNE FACE (AVEC LES PRECAUTIONS A PRENDRE EN PARALLELE ET
CFONC     PERIODIQUE : VOIR L'ECHANGE DE DT ET DE CP)
CFONC   - CALCUL D'UNE SOMME SUR LES PROCESSEURS LORS D'UN CALCUL
CFONC     PARALLELE (PARSOM)
CFONC
CFONC
CFONC IDENTIFICATION DES CELLULES/FACES DE BORD/FACES INTERNES
CFONC ========================================================
CFONC
CFONC   Les commandes GETCEL, GETFBR et GETFAC permettent d'identifier
CFONC   respectivement les cellules, faces ou faces de bord en fonction
CFONC   de differents criteres.
CFONC
CFONC   GETCEL(CHAINE,NLELT,LSTELT) :
CFONC   - CHAINE est une chaine de caractere fournie par l'utilisateur
CFONC     qui donne les criteres de selection
CFONC   - NLTELT est renvoye par la commande. C'est un entier qui
CFONC     correspond au nombre de cellules trouveees repondant au
CFONC     critere
CFONC   - LSTELT est renvoye par la commande. C'est un tableau d'entiers
CFONC     de taille NLTELT donnant la liste des cellules trouvees
CFONC     repondant au critere.
CFONC
CFONC   CHAINE peut etre constitue de :
CFONC   - references de couleurs (ex. : 1, 8, 26, ...
CFONC   - references de groupes (ex. : entrees, groupe1, ...)
CFONC   - criteres geometriques (ex. X<0.1, Y>=0.25, ...)
CFONC   Ces criteres peuvent etre combines par des operateurs logiques
CFONC   (AND et OR) et des parentheses
CFONC   ex. : '1 AND (groupe2 OR groupe3) AND Y<1' permettra de recuperer
CFONC   les cellules de couleur 1, appartenant aux groupes 'groupe2'
CFONC   ou 'groupe3' et de coordonnee Y inferieure a 1.
CFONC
CFONC   La syntaxe des commandes GETFBR et GETFAC est identique.
CFONC
CFONC
c@fonce
C-----------------------------------------------------------------------
C                             ARGUMENTS
c@argub
CARGU .______________.____._____.______________________________________.
CARGU !    NOM       !TYPE!MODE !                   ROLE               !
CARGU !______________!____!_____!______________________________________!
CARGU ! IDBIA0       ! E  !  -> ! NUMERO DE LA 1ERE CASE LIBRE DANS IA !
CARGU ! IDBRA0       ! E  !  -> ! NUMERO DE LA 1ERE CASE LIBRE DANS RA !
CARGU ! NDIM         ! E  !  -> ! DIMENSION DE L'ESPACE                !
CARGU ! NCELET       ! E  !  -> ! NOMBRE D'ELEMENTS HALO COMPRIS       !
CARGU ! NCEL         ! E  !  -> ! NOMBRE D'ELEMENTS ACTIFS             !
CARGU ! NFAC         ! E  !  -> ! NOMBRE DE FACES INTERNES             !
CARGU ! NFABOR       ! E  !  -> ! NOMBRE DE FACES DE BORD              !
CARGU ! NFML         ! E  !  -> ! NOMBRE DE FAMILLES D ENTITES         !
CARGU ! NPRFML       ! E  !  -> ! NOMBRE DE PROPRIETESE DES FAMILLES   !
CARGU ! NNOD         ! E  !  -> ! NOMBRE DE SOMMETS                    !
CARGU ! LNDFAC       ! E  !  -> ! LONGUEUR DU TABLEAU NODFAC (OPTIONNEL!
CARGU ! LNDFBR       ! E  !  -> ! LONGUEUR DU TABLEAU NODFBR (OPTIONNEL!
CARGU ! NCELBR       ! E  !  -> ! NOMBRE D'ELEMENTS AYANT AU MOINS UNE !
CARGU !              !    !     ! FACE DE BORD                         !
CARGU ! NVAR         ! E  !  -> ! NOMBRE TOTAL DE VARIABLES            !
CARGU ! NSCAL        ! E  !  -> ! NOMBRE TOTAL DE SCALAIRES            !
CARGU ! NPHAS        ! E  !  -> ! NOMBRE DE PHASES                     !
CARGU ! NBPMAX       ! E  !  -> ! NOMBRE MAX DE PARTICULES AUTORISE    !
CARGU ! NVP          ! E  !  -> ! NOMBRE DE VARIABLES PARTICULAIRES    !
CARGU ! NVEP         ! E  !  -> ! NOMBRE INFO PARTICULAIRES (REELS)    !
CARGU ! NIVEP        ! E  !  -> ! NOMBRE INFO PARTICULAIRES (ENTIERS)  !
CARGU ! NTERSL       ! E  !  -> ! NBR TERMES SOURCES DE COUPLAGE RETOUR!
CARGU ! NVLSTA       ! E  !  -> ! NOMBRE DE VAR STATISTIQUES LAGRANGIEN!
CARGU ! NVISBR       ! E  !  -> ! NOMBRE DE STATISTIQUES AUX FRONTIERES!
CARGU ! NIDEVE NRDEVE! E  !  -> ! LONGUEUR DE IDEVEL RDEVEL            !
CARGU ! NITUSE NRTUSE! E  !  -> ! LONGUEUR DE ITUSER RTUSER            !
CARGU ! IFACEL       ! TE !  -> ! ELEMENTS VOISINS D'UNE FACE INTERNE  !
CARGU ! (2, NFAC)    !    !     !                                      !
CARGU ! IFABOR       ! TE !  -> ! ELEMENT  VOISIN  D'UNE FACE DE BORD  !
CARGU ! (NFABOR)     !    !     !                                      !
CARGU ! IFMFBR       ! TE !  -> ! NUMERO DE FAMILLE D'UNE FACE DE BORD !
CARGU ! (NFABOR)     !    !     !                                      !
CARGU ! IFMCEL       ! TE !  -> ! NUMERO DE FAMILLE D'UNE CELLULE      !
CARGU ! (NCELET)     !    !     !                                      !
CARGU ! IPRFML       ! TE !  -> ! PROPRIETES D'UNE FAMILLE             !
CARGU ! NFML  ,NPRFML!    !     !                                      !
CARGU ! MAXELT       !  E !  -> ! NB MAX D'ELEMENTS (CELL,FAC,FBR)     !
CARGU ! LSTELT(MAXELT) TE !  -  ! TABLEAU DE TRAVAIL                   !
CARGU ! IPNFAC       ! TE !  -> ! POSITION DU PREMIER NOEUD DE CHAQUE  !
CARGU !   (NFAC+1)   !    !     !  FACE INTERNE DANS NODFAC (OPTIONNEL)!
CARGU ! NODFAC       ! TE !  -> ! CONNECTIVITE FACES INTERNES/NOEUDS   !
CARGU !   (LNDFAC)   !    !     !  (OPTIONNEL)                         !
CARGU ! IPNFBR       ! TE !  -> ! POSITION DU PREMIER NOEUD DE CHAQUE  !
CARGU !  (NFABOR+1)  !    !     !  FACE DE BORD DANS NODFBR (OPTIONNEL)!
CARGU ! NODFBR       ! TE !  -> ! CONNECTIVITE FACES DE BORD/NOEUDS    !
CARGU !   (LNDFBR  ) !    !     !  (OPTIONNEL)                         !
CARGU ! ITEPA        ! TE !  -> ! INFO PARTICULAIRES (ENTIERS)         !
CARGU ! (NBPMAX,NIVEP!    !     !   (CELLULE DE LA PARTICULE,...)      !
CARGU ! IDEVEL(NIDEVE! TE ! <-> ! TAB ENTIER COMPLEMENTAIRE DEVELOPEMT !
CARGU ! ITUSER(NITUSE! TE ! <-> ! TAB ENTIER COMPLEMENTAIRE UTILISATEUR!
CARGU ! IA(*)        ! TR !  -  ! MACRO TABLEAU ENTIER                 !
CARGU ! XYZCEN       ! TR !  -> ! POINT ASSOCIES AUX VOLUMES DE CONTROL!
CARGU ! (NDIM,NCELET !    !     !                                      !
CARGU ! SURFAC       ! TR !  -> ! VECTEUR SURFACE DES FACES INTERNES   !
CARGU ! (NDIM,NFAC)  !    !     !                                      !
CARGU ! SURFBO       ! TR !  -> ! VECTEUR SURFACE DES FACES DE BORD    !
CARGU ! (NDIM,NFABOR)!    !     !                                      !
CARGU ! CDGFAC       ! TR !  -> ! CENTRE DE GRAVITE DES FACES INTERNES !
CARGU ! (NDIM,NFAC)  !    !     !                                      !
CARGU ! CDGFBO       ! TR !  -> ! CENTRE DE GRAVITE DES FACES DE BORD  !
CARGU ! (NDIM,NFABOR)!    !     !                                      !
CARGU ! XYZNOD       ! TR !  -> ! COORDONNES DES NOEUDS (OPTIONNEL)    !
CARGU ! (NDIM,NNOD)  !    !     !                                      !
CARGU ! VOLUME       ! TR !  -> ! VOLUME D'UN DES NCELET ELEMENTS      !
CARGU ! (NCELET      !    !     !                                      !
CARGU ! DT(NCELET)   ! TR !  -> ! PAS DE TEMPS                         !
CARGU ! RTP, RTPA    ! TR !  -> ! VARIABLES DE CALCUL AU CENTRE DES    !
CARGU ! (NCELET,*)   !    !     !    CELLULES (INSTANT COURANT OU PREC)!
CARGU ! PROPCE       ! TR !  -> ! PROPRIETES PHYSIQUES AU CENTRE DES   !
CARGU ! (NCELET,*)   !    !     !    CELLULES                          !
CARGU ! PROPFA       ! TR !  -> ! PROPRIETES PHYSIQUES AU CENTRE DES   !
CARGU !  (NFAC,*)    !    !     !    FACES INTERNES                    !
CARGU ! PROPFB       ! TR !  -> ! PROPRIETES PHYSIQUES AU CENTRE DES   !
CARGU !  (NFABOR,*)  !    !     !    FACES DE BORD                     !
CARGU ! COEFA, COEFB ! TR !  -> ! CONDITIONS AUX LIMITES AUX           !
CARGU !  (NFABOR,*)  !    !     !    FACES DE BORD                     !
CARGU ! ETTP         ! TR !  -> ! TABLEAUX DES VARIABLES LIEES         !
CARGU !  (NBPMAX,NVP)!    !     !   AUX PARTICULES ETAPE COURANTE      !
CARGU ! ETTPA        ! TR !  -> ! TABLEAUX DES VARIABLES LIEES         !
CARGU !  (NBPMAX,NVP)!    !     !   AUX PARTICULES ETAPE PRECEDENTE    !
CARGU ! TEPA         ! TR !  -> ! INFO PARTICULAIRES (REELS)           !
CARGU ! (NBPMAX,NVEP)!    !     !   (POIDS STATISTIQUES,...)           !
CARGU ! STATIS       ! TR !  -> ! MOYENNES STATISTIQUES                !
CARGU !(NCELET,NVLSTA!    !     !                                      !
CARGU ! STATIV       ! TR !  -> ! CUMUL POUR LES VARIANCES DES         !
CARGU !(NCELET,      !    !     !    STATISTIQUES VOLUMIQUES           !
CARGU !   NVLSTA-1)  !    !     !                                      !
CARGU ! TSLAGR       ! TR !  -> ! TERME DE COUPLAGE RETOUR DU          !
CARGU !(NCELET,NTERSL!    !     !   LAGRANGIEN SUR LA PHASE PORTEUSE   !
CARGU ! PARBOR       ! TR !  -> ! INFOS SUR INTERACTION DES PARTICULES !
CARGU !(NFABOR,NVISBR!    !     !   AUX FACES DE BORD                  !
CARGU ! RDEVEL(NRDEVE! TR ! <-> ! TAB REEL COMPLEMENTAIRE DEVELOPEMT   !
CARGU ! RTUSER(NRTUSE! TR ! <-> ! TAB REEL COMPLEMENTAIRE UTILISATEUR  !
CARGU ! RA(*)        ! TR !  -  ! MACRO TABLEAU REEL                   !
CARGU !______________!____!_____!______________________________________!
c@argue
C
c@commb
CCOMM                             COMMONS
CCOMM .______________.____._____.______________________________________.
CCOMM !    NOM       !TYPE!MODE !                   ROLE               !
CCOMM !______________!____!_____!______________________________________!
CCOMM !______________!____!_____!______________________________________!
c@comme
C
C     TYPE : E (ENTIER), R (REEL), A (ALPHANUMERIQUE), T (TABLEAU)
C            L (LOGIQUE)   .. ET TYPES COMPOSES (EX : TR TABLEAU REEL)
C     MODE : -> DONNEE, <- RESULTAT, <-> DONNEE MODIFIEE,
C            - TABLEAU DE TRAVAIL
C***********************************************************************
C
      IMPLICIT NONE
C
C***********************************************************************
C     DONNEES EN COMMON
C***********************************************************************
C
      INCLUDE "dimfbr.h"
      INCLUDE "paramx.h"
      INCLUDE "pointe.h"
      INCLUDE "numvar.h"
      INCLUDE "optcal.h"
      INCLUDE "cstphy.h"
      INCLUDE "cstnum.h"
      INCLUDE "entsor.h"
      INCLUDE "lagpar.h"
      INCLUDE "lagran.h"
      INCLUDE "parall.h"
      INCLUDE "period.h"
      INCLUDE "ppppar.h"
      INCLUDE "ppthch.h"
      INCLUDE "ppincl.h"
C
C***********************************************************************
C
C ARGUMENTS
C
      INTEGER          IDBIA0 , IDBRA0
      INTEGER          NDIM   , NCELET , NCEL   , NFAC   , NFABOR
      INTEGER          NFML   , NPRFML
      INTEGER          NNOD   , LNDFAC , LNDFBR , NCELBR
      INTEGER          NVAR   , NSCAL  , NPHAS
      INTEGER          NBPMAX , NVP    , NVEP  , NIVEP
      INTEGER          NTERSL , NVLSTA , NVISBR
      INTEGER          NIDEVE , NRDEVE , NITUSE , NRTUSE
C
      INTEGER          IFACEL(2,NFAC) , IFABOR(NFABOR)
      INTEGER          IFMFBR(NFABOR) , IFMCEL(NCELET)
      INTEGER          IPRFML(NFML,NPRFML)
      INTEGER          MAXELT, LSTELT(MAXELT)
      INTEGER          IPNFAC(NFAC+1), NODFAC(LNDFAC)
      INTEGER          IPNFBR(NFABOR+1), NODFBR(LNDFBR)
      INTEGER          ITEPA(NBPMAX,NIVEP)
      INTEGER          IDEVEL(NIDEVE), ITUSER(NITUSE)
      INTEGER          IA(*)
C
      DOUBLE PRECISION XYZCEN(NDIM,NCELET)
      DOUBLE PRECISION SURFAC(NDIM,NFAC), SURFBO(NDIM,NFABOR)
      DOUBLE PRECISION CDGFAC(NDIM,NFAC), CDGFBO(NDIM,NFABOR)
      DOUBLE PRECISION XYZNOD(NDIM,NNOD), VOLUME(NCELET)
      DOUBLE PRECISION DT(NCELET), RTP(NCELET,*), RTPA(NCELET,*)
      DOUBLE PRECISION PROPCE(NCELET,*)
      DOUBLE PRECISION PROPFA(NFAC,*), PROPFB(NDIMFB,*)
      DOUBLE PRECISION COEFA(NDIMFB,*), COEFB(NDIMFB,*)
      DOUBLE PRECISION ETTP(NBPMAX,NVP) , ETTPA(NBPMAX,NVP)
      DOUBLE PRECISION TEPA(NBPMAX,NVEP)
      DOUBLE PRECISION STATIS(NCELET,NVLSTA), STATIV(NCELET,NVLSTA-1)
      DOUBLE PRECISION TSLAGR(NCELET,NTERSL)
      DOUBLE PRECISION PARBOR(NFABOR,NVISBR)
      DOUBLE PRECISION RDEVEL(NRDEVE), RTUSER(NRTUSE), RA(*)
C
C VARIABLES LOCALES
C
      INTEGER          IDEBIA, IDEBRA
      INTEGER          IEL    , IELG   , IFAC   , IFACG  , IVAR
      INTEGER          IEL1   , IEL2   , IELTSM
      INTEGER          IORTHO , IMPOUT
      INTEGER          IFINIA , IFINRA
      INTEGER          IGRADX , IGRADY , IGRADZ
      INTEGER          ITRAVX , ITRAVY , ITRAVZ , ITRECO
      INTEGER          INC    , ICCOCG
      INTEGER          NSWRGP , IMLIGP , IPHYDP , IWARNP
      INTEGER          IUTILE , IPHAS  , ICLVAR , III
      INTEGER          IPCROM , IPCVST , IFLMAS , IFLMAB , IPCCP, IPCVSL
      INTEGER          IDIMTE , ITENSO , ISCAL
      INTEGER          II     , NBR    , IRANGV , IRANG1 , NPOINT
      INTEGER          IMOM   , IPCMOM , IDTCM
      INTEGER          ITAB(3), IUN
      INTEGER          NCESMP , ICESMP , ISMACP , ITPSMP
      INTEGER          ILELT  , NLELT
C
      DOUBLE PRECISION XRTPA  , XRTP
      DOUBLE PRECISION XBILAN , XBILVL , XBILPA , XBILPT
      DOUBLE PRECISION XBILSY , XBILEN , XBILSO , XBILDV
      DOUBLE PRECISION XBILMI , XBILMA
      DOUBLE PRECISION EPSRGP , CLIMGP , EXTRAP
      DOUBLE PRECISION XFLUXF , XGAMMA
      DOUBLE PRECISION DIIPBX, DIIPBY, DIIPBZ, SURFBN, DISTBR
      DOUBLE PRECISION VISCT, FLUMAB , XCP , XVSL, CP0IPH, RRR
      DOUBLE PRECISION XYZ(3), XABS, XU, XV, XW, XK, XEPS
C
      INTEGER          ITER, IMP
      INTEGER          NMAX
      PARAMETER (NMAX = 20000)
C                       ~~~~~~
      DOUBLE PRECISION TEMPS, TTFIN, MILIEU
      DOUBLE PRECISION Z1, Z2, Z3, AA, BB, CC
      DOUBLE PRECISION BET, GAM, TAU
      DOUBLE PRECISION EPSI, XXK, NUM, DEN
      DOUBLE PRECISION XX, XLL1, XL1, X12, X2R, X2RR
      DOUBLE PRECISION RHOL, UL, PL, HL, CL
      DOUBLE PRECISION RHO1, U1, P1, H1, C1, SIG1
      DOUBLE PRECISION RHO2, U2, P2, H2, C2, SIG2
      DOUBLE PRECISION RHOR, UR, PR, HR, CR
      DOUBLE PRECISION ERRRHO, ERRU, ERRP, ERRH
      DOUBLE PRECISION XL1RHO, XL1U, XL1P, XL1H
C
      DOUBLE PRECISION UEX(NMAX), PEX(NMAX), RHOEX(NMAX), HEX(NMAX)
      DOUBLE PRECISION UGB(NMAX), PGB(NMAX), RHOGB(NMAX), HGB(NMAX)
      DOUBLE PRECISION XYZCGB(NMAX)
C
C***********************************************************************
C
C
C
C=======================================================================
C 1. INITIALISATION
C=======================================================================
C
C ---> Gestion memoire
C
      IDEBIA = IDBIA0
      IDEBRA = IDBRA0
C
C
C ---> Test allocation memoire 
C
      IF(NMAX.LT.NCELGB) THEN
        WRITE(NFECRA,9000)NCELGB
        CALL CSEXIT(1)
      ENDIF
 9000 FORMAT(' AUGMENTER NMAX DANS USPROJ AU MOINS A ',I10)
C
C  Le bilan n'est pas valable si INPDT0=1
      IF (INPDT0.EQ.0) THEN
C
C=======================================================================
C 1. AFFICHAGE DE X, P, U, RHO, H CALCULES ET EXACTS, ET DE L'ERREUR L1
C=======================================================================
C
C   TEST SI ON CALCULE OU NON 
C   =========================
C
C --- Instant courant
      TEMPS  = TTCABS
C
C --- Instant de l'affichage (arbitraire)
      TTFIN  = 0.3D0
C
C --- Pour l'affichage
      IF(TEMPS.GE.TTFIN.OR.NTCABS.EQ.NTMABS) THEN
C
C   INITIALISATION
C   ==============
C
C ---- Arret du calcul
        NTMABS = NTCABS 
C
C
C --- Definition de l'tat 
C
C --- Gamma
        GAM = CP0(1)/(CP0(1)-RR/28.8D-3)
C
C --- Etat L 
        RHOL = 1.D0
        UL   = 0.D0
        PL   = 1.D5
        HL   = GAM/(GAM-1.D0)*PL/RHOL
        CL   = SQRT(GAM*PL/RHOL)
C
C --- Etat R
        RHOR = 0.125D0
        UR   = 0.D0
        PR   = 1.D4
        HR   = GAM/(GAM-1.D0)*PR/RHOR
        CR   = SQRT(GAM*PR/RHOR)
C
C --- Separation
        MILIEU = 0.D0
C
C --- Precision dans la methode de Newton
        EPSI = 1.D-9
C
C --- Initialisations (champs et erreurs)
C
        DO IEL = 1, NCELGB
          UEX(IEL)   = 0.D0
          PEX(IEL)   = 0.D0
          RHOEX(IEL) = 0.D0
          HEX(IEL)   = 0.D0
        ENDDO
C
        ERRRHO = 0.D0
        ERRU   = 0.D0
        ERRP   = 0.D0
        ERRH   = 0.D0
        XL1RHO = 0.D0
        XL1U   = 0.D0
        XL1P   = 0.D0
        XL1H   = 0.D0
C
C
C   CONDITION D'APPARITION DU VIDE
C   ==============================
C
        IF(UR-UL.GE.2.D0/(GAM-1.D0)*(CL+CR)) THEN
          WRITE(NFECRA,8000)
          CALL CSEXIT (1)
        ENDIF
C
 8000   FORMAT('LE PROBLEME NE PEUT ETRE RESOLU ',/,
     &         '  A CAUSE DE L''APPARITION DU VIDE DANS LE TUBE')
C
C
C
C ECHANGE DES DONNEES
C ===================
C
C     ...
        IPHAS = 1
C
C     En sequentiel, on duplique (pour simplifier)
        IF(IRANGP.LT.0) THEN 
C
          DO IEL = 1, NCELGB
            XYZCGB(IEL) = XYZCEN(1,IEL)
            UGB   (IEL) = RTP(IEL,IU (IPHAS))
            PGB   (IEL) = RTP(IEL,IPR(IPHAS))
            RHOGB (IEL) = RTP(IEL,ISCA(IRHO  (IPHAS)))
            HGB   (IEL) = RTP(IEL,ISCA(IENERG(IPHAS)))
     &           - 0.5D0*RTP(IEL,IU (IPHAS))**2
     &           + RTP(IEL,IPR(IPHAS))/RTP(IEL,ISCA(IRHO  (IPHAS)))
          ENDDO
C
C     En parallele, on annule, puis 
C       chaque processeur remplit son morceau et on somme
        ELSE
C
          DO IEL = 1, NCELGB
            XYZCGB(IEL) = 0.D0
            UGB   (IEL) = 0.D0
            PGB   (IEL) = 0.D0
            RHOGB (IEL) = 0.D0
            HGB   (IEL) = 0.D0
          ENDDO
          DO IEL = 1, NCEL
            CALL PARCLG(IEL,IRANGP,IELG)
            XYZCGB(IELG) = XYZCEN(1,IEL)
            UGB   (IELG) = RTP(IEL,IU (IPHAS))
            PGB   (IELG) = RTP(IEL,IPR(IPHAS))
            RHOGB (IELG) = RTP(IEL,ISCA(IRHO  (IPHAS)))
            HGB   (IELG) = RTP(IEL,ISCA(IENERG(IPHAS)))
     &           - 0.5D0*RTP(IEL,IU (IPHAS))**2
     &           + RTP(IEL,IPR(IPHAS))/RTP(IEL,ISCA(IRHO  (IPHAS)))
          ENDDO
          CALL PARRSM(NCELGB,XYZCGB)
          CALL PARRSM(NCELGB,UGB)
          CALL PARRSM(NCELGB,PGB)
          CALL PARRSM(NCELGB,RHOGB)
          CALL PARRSM(NCELGB,HGB)
C
        ENDIF
C
C SOLUTION EXACTE
C ===============
C
C     Seul un processeur la calcule 
        IF(IRANGP.LE.0) THEN 
C
C
C   RESOLUTION
C   ----------
          AA  = RHOR / RHOL
          BB  = PR / PL
          CC  = (UR - UL) / CL
          BET = (GAM + 1.D0) / (GAM - 1.D0)
          TAU = (GAM - 1.D0) / (2.D0 * GAM)
C
C --- Resolution de Z1 par la methode de Newton
          XXK  = 0.D0
          ITER = 0
C
 777      CONTINUE
C
          Z1  = XXK
          ITER = ITER + 1
C
          NUM = -CC
          IF(Z1.GE.0.D0) THEN
            NUM = NUM  +  2.D0/(GAM-1.D0) * (1.D0-EXP(-TAU*Z1))
          ELSE
            NUM = NUM  +  2.D0*SQRT(TAU)/(GAM-1.D0)
     &           * (1.D0 - EXP(-Z1)) / SQRT(1.D0 + BET*EXP(-Z1))
          ENDIF
          IF(Z1.GE.-LOG(BB)) THEN
            NUM = NUM  +  SQRT(BB/AA) * 2.D0/(GAM-1.D0)
     &           * (1.D0 - EXP( -TAU*(Z1+LOG(BB)) ))
          ELSE
            NUM = NUM  +  SQRT(BB/AA) * 2.D0*SQRT(TAU)/(GAM-1.D0)
     &           * (1.D0 - EXP( -Z1-LOG(BB) ))
     &           / SQRT(1.D0 + BET*EXP( -Z1-LOG(BB) ))
          ENDIF
C
          DEN = 0.D0
          IF(Z1.GE.0.D0) THEN
            DEN = DEN  +  2.D0*TAU/(GAM-1.D0) * EXP(-TAU*Z1)
          ELSE
            DEN = DEN  +  2.D0*SQRT(TAU)/(GAM-1.D0)
     &           * EXP(-Z1) * ( 1.D0 + BET/2.D0*(1.D0+EXP(-Z1)) )
     &           / (1.D0 + BET*EXP(-Z1))**1.5D0
          ENDIF
          IF(Z1.GE.-LOG(BB)) THEN
            DEN = DEN  +  SQRT(BB/AA) * 2.D0*TAU/(GAM-1.D0)
     &           * EXP( -TAU*(Z1+LOG(BB)) )
          ELSE
            DEN = DEN  +  SQRT(BB/AA) * 2.D0*SQRT(TAU)/(GAM-1.D0)
     &           * EXP(-Z1-LOG(BB))
     &           * ( 1.D0 + BET/2.D0*(1.D0+EXP(-Z1-LOG(BB))) )
     &           / (1.D0 + BET*EXP(-Z1-LOG(BB)))**1.5D0
          ENDIF
          IF(DEN.EQ.0.D0) DEN = 1.D0
          IF(ABS(DEN).LT.1.D-3) DEN = SIGN(1.D0,DEN) * 1.D-3
C     
          XXK = Z1 - NUM/DEN
C
          IF(ABS(NUM/DEN).GE.EPSI) GOTO 777
C
C --- Resolution de Z3 et Z2
          Z3 = Z1 + LOG(BB)
C
          Z2 = LOG(AA)
          IF(Z1.GE.0.D0) THEN
            Z2 = Z2 + Z1/GAM
          ELSE
            Z2 = Z2 - LOG( (BET + EXP(Z1)) / (1.D0 + BET*EXP(Z1)) )
          ENDIF
          IF(Z3.GE.0.D0) THEN
            Z2 = Z2 - Z3/GAM
          ELSE
            Z2 = Z2 + LOG( (BET + EXP(Z3)) / (1.D0 + BET*EXP(Z3)) )
          ENDIF
C
C --- Resolution des variables
          IF(Z1.GE.0.D0) THEN
            RHO1 = RHOL * EXP(-Z1/GAM)
            U1   = UL  +  2 * CL * (1.D0 - EXP(-TAU*Z1)) / (GAM-1.D0)
          ELSE
            RHO1 = RHOL * ( BET + EXP(Z1) ) / ( 1.D0 + BET*EXP(Z1) )
            U1   = UL  +  2 * CL / (GAM-1.D0) * SQRT(TAU)
     &           * ( 1.D0 - EXP(-Z1) ) / SQRT( 1.D0 + BET*EXP(-Z1) )
            SIG1 = (RHO1*U1 - RHOL*UL) / (RHO1 - RHOL)
          ENDIF
          P1   = PL * EXP(-Z1)
          C1   = SQRT(GAM*P1/RHO1)
C     
          RHO2 = RHO1 * EXP(Z2)
          U2   = U1
          P2   = P1
          C2   = SQRT(GAM*P2/RHO2)
C
          IF(Z3.LT.0.D0) THEN
            SIG2 = (RHOR*UR - RHO2*U2) / (RHOR - RHO2)
          ENDIF
C
C     Separation des etats
          XLL1 = TEMPS*(UL-CL)
          IF(Z1.LT.0.D0) THEN
            XL1  = TEMPS*SIG1
          ELSE
            XL1 = TEMPS*(U1-C1)
          ENDIF
          X12  = TEMPS*U1
          IF(Z3.LT.0.D0) THEN
            X2R  = TEMPS*SIG2
          ELSE
            X2R = TEMPS*(U2+C2)
          ENDIF
          X2RR = TEMPS*(UR+CR)
C     
          DO IEL = 1, NCELGB
            XX = XYZCGB(IEL) - MILIEU
C     Etat L
            IF(Z1.GE.0.D0.AND.XX.LE.XLL1.OR.
     &         Z1.LT.0.D0.AND.XX.LE.XL1) THEN
              RHOEX(IEL) = RHOL
              UEX(IEL)   = UL
              PEX(IEL)   = PL
            ENDIF
C     Etat L-1
            IF(Z1.GE.0.D0 .AND. XX.GT.XLL1 .AND. XX.LE.XL1) THEN
              UEX(IEL)   = XX/TEMPS*2.D0/(GAM+1.D0)
     &             + (UL+2.D0/(GAM-1.D0)*CL)/BET
              RHOEX(IEL) = RHOL*((UEX(IEL)-XX/TEMPS)/CL)
     &             **(2.D0/(GAM-1.D0))
              PEX(IEL)   = PL*(RHOEX(IEL)/RHOL)**GAM
            ENDIF
C     Etat 1
            IF(XX.GT.XL1 .AND. XX.LE.X12) THEN
              RHOEX(IEL) = RHO1
              UEX(IEL)   = U1
              PEX(IEL)   = P1
            ENDIF
C     Etat 2
            IF(XX.GT.X12 .AND. XX.LE.X2R) THEN
              RHOEX(IEL) = RHO2
              UEX(IEL)   = U2
              PEX(IEL)   = P2
            ENDIF
C     Etat 2-R
            IF(Z3.GE.0.D0 .AND. XX.GT.X2R .AND. XX.LE.X2RR) THEN
              UEX(IEL)   = XX/TEMPS*2.D0/(GAM+1.D0)
     &             + (UR-2.D0/(GAM-1.D0)*CR)/BET
              RHOEX(IEL) = RHOR*((XX/TEMPS-UEX(IEL))/CR)
     &             **(2.D0/(GAM-1.D0))
              PEX(IEL)   = PR*(RHOEX(IEL)/RHOR)**GAM
            ENDIF
C     Etat R
            IF(Z3.GE.0.D0.AND.XX.GT.X2RR.OR.
     &         Z3.LT.0.D0.AND.XX.GT.X2R) THEN
              RHOEX(IEL) = RHOR
              UEX(IEL)   = UR
              PEX(IEL)   = PR
            ENDIF
C
C     Enthalpie
            HEX(IEL) = GAM/(GAM-1.D0) * PEX(IEL)/RHOEX(IEL)
C
C     Erreur L1
            IPHAS=1
            ERRRHO = ERRRHO + ABS( RHOGB(IEL) - RHOEX(IEL) )
            ERRU   = ERRU   + ABS( UGB(IEL)   - UEX(IEL)   )
            ERRP   = ERRP   + ABS( PGB(IEL)   - PEX(IEL)   )
            ERRH   = ERRH   + ABS( HGB(IEL)   - HEX(IEL)   )
            XL1RHO = XL1RHO + ABS( RHOEX(IEL) )
            XL1U   = XL1U   + ABS( UEX(IEL)   )
            XL1P   = XL1P   + ABS( PEX(IEL)   )
            XL1H   = XL1H   + ABS( HEX(IEL)   )
C
          ENDDO
C
          ERRRHO = LOG(ERRRHO / MAX( 1.D-12 , XL1RHO )) / LOG(1.D1)
          ERRU   = LOG(ERRU   / MAX( 1.D-12 , XL1U   )) / LOG(1.D1)
          ERRP   = LOG(ERRP   / MAX( 1.D-12 , XL1P   )) / LOG(1.D1)
          ERRH   = LOG(ERRH   / MAX( 1.D-12 , XL1H   )) / LOG(1.D1)
C
C
C FICHIERS DE SORTIES
C ===================
C
C   CHOIX DU NOM DES FICHIERS
C   -------------------------
C
          IMP = IMPUSR(1)
C
          OPEN(UNIT=IMP,FILE='massevol.dat')
          WRITE(IMP,1001) '#','masse volumique',NCELGB,TEMPS,NTCABS
          WRITE(IMP,1002) '#','x','exact','calcule'
          DO IEL = 1, NCELGB
            WRITE(IMP,1000) XYZCGB(IEL), RHOEX(IEL),RHOGB(IEL)
          ENDDO
          CLOSE(IMP)
C
          OPEN(UNIT=IMP,FILE='vitessex.dat')
          WRITE(IMP,1001) '#','vitesse x',NCELGB,TEMPS,NTCABS
          WRITE(IMP,1002) '#','x','exact','calcule'
          DO IEL = 1, NCELGB
            WRITE(IMP,1000) XYZCGB(IEL), UEX(IEL),UGB(IEL)
          ENDDO
          CLOSE(IMP)
C
          OPEN(UNIT=IMP,FILE='pression.dat')
          WRITE(IMP,1001) '#','pression',NCELGB,TEMPS,NTCABS
          WRITE(IMP,1002) '#','x','exact','calcule'
          DO IEL = 1, NCELGB
            WRITE(IMP,1000) XYZCGB(IEL), PEX(IEL),PGB(IEL)
          ENDDO
          CLOSE(IMP)
C
          OPEN(UNIT=IMP,FILE='enthalpi.dat')
          WRITE(IMP,1001) '#','enthalpie',NCELGB,TEMPS,NTCABS
          WRITE(IMP,1002) '#','x','exact','calcule'
          DO IEL = 1, NCELGB
            WRITE(IMP,1000) XYZCGB(IEL), HEX(IEL),HGB(IEL)
          ENDDO
          CLOSE(IMP)
C
C
          OPEN(UNIT=IMP,FILE='erreurl1.dat')
          WRITE(IMP,1001) '#','erreur L1',NCELGB,TEMPS,NTCABS
          WRITE(IMP,1002) '#','log10(Dx)','log10(err rho)',
     &                                    'log10(err u  )',
     &                                    'log10(err p  )',
     &                                    'log10(err h  )'
          WRITE(IMP,1000) LOG(XYZCEN(1,2)-XYZCEN(1,1))/LOG(1.D1),
     &         ERRRHO, ERRU, ERRP, ERRH       
          CLOSE(IMP)
C
C
          WRITE(NFECRA,2000) ITER, NUM/DEN, Z1, Z2, Z3
C
        ENDIF
C
C
      ENDIF
C
      ENDIF
C
C FORMATS
C
 1001     FORMAT(A1,1X,A20,', Nombre de cellules = ',I10,
     &                     ', Temps = ',E14.5,
     &                     ', Nombre de pas de temps = ',I10)
 1002     FORMAT(A1,1X,3A18)
 1000     FORMAT(  2X,3E18.8)
C
 2000 FORMAT(/,/,

     &'   ** RESOLUTION EXACTE DU CAS'                               ,/,
     &'      ------------------------'                               ,/,
     &                                                                /,
     &'      NOMBRE D''ITERATIONS DE LA METHODE DE NEWTON : ',I8     ,/,
     &'      RESIDU FINAL : ',E12.4                                  ,/,
     &'      Z1 = ',E12.4                                            ,/,
     &'      Z2 = ',E12.4                                            ,/,
     &'      Z3 = ',E12.4                                          ,/,/)
C
      RETURN
      END
c@z
